//
// Created by #Suyghur, on 2021/06/16.
//

#include "include/base64_utils.h"
#include <third_part/openssl/bio.h>
#include <third_part/openssl/pem.h>

std::string Base64Utils::Encode(const std::string &src) {
    BIO *bio;
    BIO *b64;
    BUF_MEM *buffer_ptr;

    b64 = BIO_new(BIO_f_base64());
    BIO_set_flags(b64, BIO_FLAGS_BASE64_NO_NL);
    bio = BIO_new(BIO_s_mem());
    bio = BIO_push(b64, bio);
    //encode
    BIO_write(bio, src.c_str(), (int) src.length());
    BIO_flush(bio);
    BIO_get_mem_ptr(bio, &buffer_ptr);
    std::string raw(buffer_ptr->data, buffer_ptr->length);
    BIO_free_all(bio);
    return raw;
}

char *Base64Utils::Decode(const char *raw) {
    BIO *b64 = nullptr;
    BIO *bmem = nullptr;
    int len = strlen(raw);
    char *buffer = (char *) malloc(len);
    memset(buffer, 0, len);
    b64 = BIO_new(BIO_f_base64());
    BIO_set_flags(b64, BIO_FLAGS_BASE64_NO_NL);
    bmem = BIO_new_mem_buf(raw, len);
    bmem = BIO_push(b64, bmem);
    BIO_read(bmem, buffer, len);
    BIO_free_all(bmem);
    return buffer;
}
