package cn.yyxx.columbus.core.utils

import android.content.Context
import cn.yyxx.columbus.base.utils.Logger
import com.tencent.mmkv.MMKV
import com.tencent.mmkv.MMKVHandler
import com.tencent.mmkv.MMKVLogLevel
import com.tencent.mmkv.MMKVRecoverStrategic
import java.io.File


/**
 * @author #Suyghur.
 * Created on 2021/06/25
 */
class MMKVUtils private constructor() : MMKVHandler {

    var mmkv: MMKV? = null

    fun init(context: Context) {
        MMKV.initialize(context, context.getExternalFilesDir("")!!.absolutePath + File.separator + "/user_info")
        mmkv = MMKV.defaultMMKV()
    }

    override fun onMMKVCRCCheckFail(mmapID: String?): MMKVRecoverStrategic {
        return MMKVRecoverStrategic.OnErrorDiscard
    }

    override fun onMMKVFileLengthError(mmapID: String?): MMKVRecoverStrategic {
        return MMKVRecoverStrategic.OnErrorDiscard
    }


    override fun wantLogRedirecting(): Boolean {
        return false
    }

    override fun mmkvLog(level: MMKVLogLevel?, file: String?, line: Int, function: String?, message: String?) {
        val log = "<${file.toString()}:${line}::${function}>${message}"
        Logger.i(log)
    }

    companion object {
        fun getInstance(): MMKVUtils {
            return MMKVUtilsHolder.INSTANCE
        }
    }

    private object MMKVUtilsHolder {
        val INSTANCE: MMKVUtils = MMKVUtils()
    }
}